program Set_01;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

//      

function MakeSet(const arg: string): TSet;
var i: integer;
    t: TItem;
begin
  Result:= CreateSet;   //   
  for i:= 1 to Length(arg) do begin
    t:= TItemChar.Create(UpCase(arg[i]));  //  -
    if not Result.Insert(t)  //      
      then t.Free;           //   
  end;
end;

var A, B, C : TSet;    //   

begin
  try
    //   :
    A:= MakeSet('Pascal');  // A = { A,C,L,P,S }
    B:= MakeSet('Delphi');  // B = { D,E,H,I,L,P }
    C:= CreateSet;          // C = { }
    Write('      A = '); A.Expo;
    Write('      B = '); B.Expo;
    // :
    Write('    A+B = ');
    C.CopyItems(A);
    C.Add(B);
    C.Expo;                { A,C,D,E,H,I,L,P,S }
    // :
    Write('    A-B = ');
    C.CopyItems(A);
    C.Sub(B);
    C.Expo;                { A,C,S }
    // :
    Write('    A*B = ');
    C.CopyItems(A);
    C.Mul(B);
    C.Expo;                { L,P }
    //  :
    Write('A xor B = ');
    C.CopyItems(A);
    C.ExOr(B);
    C.Expo;                { A,C,D,E,H,I,S }

    //  :
    C.Free;           //    
    B.ClrAndDestroy;  //   
    B.Free;           //  
    A.ClrAndDestroy;  //   
    A.Free;           //  
    Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
