﻿program Set_10c;

{$APPTYPE CONSOLE}

{-define OUT}

uses
  SysUtils,
  DateUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

////////////////////////////////////////////////////////////////

var
    Power   : integer;   // Мощность исходного множества
    Univers : TSet;      // Исходное базовое множество (универсум)
    BufSubs: TBuffer;  // Исходное множество подмножеств
    CostBuf: TBuffer;
    CS: TCostSet;
    Start, Time : TDateTime;
////////////////////////////////////////////////////////////////

begin
  try
    //Randomize;

    if ParamCount = 0 then begin
      Write('Power= '); Readln(Power);
      if Power<3 then exit;
      //Power:=11;
      Univers:= GenerateChars(Power);
      // Генерация произвольных разбиений
      BufSubs:= GenSubsRand(Univers, 200, 0, 40);
    end else begin
      // Генерация подмножеств из файла
      BufSubs:= GenSubsFromText('Input.txt', Univers, 75);
    end;

    {$ifdef OUT}
    Assign(Output,'Out.txt'); Rewrite(Output);
    {$endif}

    Univers.Expo;
    Writeln('- - - - - - - - - - - - - - - - - - - - - -');

    // Добавление к подмножествам оценок
    {
     0: cost:= 1 + Random(99);
     1: cost:= 1;
     2: cost:= 1 + (n div 2) + Random(n);
     3: cost:= n;
     4: cost:= 1 + (n-1)*(n-1);
    }
    CostBuf:= GenCostItems(1, BufSubs);
    BufSubs.Free;
    //CostBuf.Expo;
    //Writeln('- - - - - - - - - - - - - - - - - - - - - -');

    Start:= Now;
    CS:= CollectMinDissect(Univers, CostBuf);
    Time:= MilliSecondsBetween(Start, Now);
    CS.Expo;
    CS.Free;
    Writeln('Time (ms) = ', Time:6:0);
    Writeln('- - - - - - - - - - - - - - - - - - - - - -');

    Start:= Now;
    CS:= CollectMinCover(Univers, CostBuf);
    Time:= MilliSecondsBetween(Start, Now);
    CS.Expo;
    CS.Free;
    Writeln('Time (ms) = ', Time:6:0);
    Writeln('- - - - - - - - - - - - - - - - - - - - - -');
    
    Start:= Now;
    CS:= CollectGradCover(Univers, CostBuf);
    Time:= MilliSecondsBetween(Start, Now);
    CS.Expo;
    CS.Free;
    Writeln('Time (ms) = ', Time:6:0);
    Writeln('- - - - - - - - - - - - - - - - - - - - - -');
(*
repeat
    Start:= Now;
    CS:= CollectGradCover(Univers, CostBuf);
    CS.Expo;
    CS.Free;
    Time:= MilliSecondsBetween(Start, Now);
    Writeln('Time (ms) = ', Time:6:0);
    Writeln('- - - - - - - - - - - - - - - - - - - - - -');
    Write('S= '); Readln(S);
until S<>'';
*)
    /////////////////////////////////////
    CostBuf.Free;
    Univers.ClrAndDestroy;
    Univers.Free;

    {$ifdef OUT}
      Close(Output);
    {$else}
      Write('OK');
      Readln;
    {$endif}

  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
