program Graph_15b;
//////////////////////////////////////////////////////////////
///      
///  (  )
///       (GenPath)
///     (GenDijkstra)

{$APPTYPE CONSOLE}

uses
  SysUtils,  DateUtils,
  Graph in '..\Common\Graph.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  GrChars in '..\Common\GrChars.pas';

//////////////////////////////////////////////////////////////

var Gr : TGraphChars;
    P1, P2 : TBuffer;
    NodeA, NodeB : TNode;

//////////////////////////////////////////////////////////////
///    
(*
procedure Save;
const CName = 'Out.txt';
var F: TextFile;
    P : TBuffer;
begin
  Gr.Save(CName);
  AssignFile(F, CName);
  if FileExists(CName) then Append(F) else Rewrite(F);
  Writeln(F,'- - - - - - - - - - - - - - - - - -');
  Gr.Print(F);
  Writeln(F,'- - - - - - - - - - - - - - - - - -');

  P:= Gr.GenPath(NodeA, NodeB);
  if Assigned(P) then begin P.Print(F);  P.Free;  end;
  Writeln(F,'- - - - - - - - - - - - - - - - - -');

  P:= Gr.GenDijkstra(NodeA, NodeB);
  if Assigned(P) then begin P.Print(F);  P.Free;  end;
  Writeln(F,'- - - - - - - - - - - - - - - - - -');

  P:= Gr.GenPath(NodeB, NodeA);
  if Assigned(P) then begin P.Print(F);  P.Free;  end;
  Writeln(F,'- - - - - - - - - - - - - - - - - -');

  P:= Gr.GenDijkstra(NodeB, NodeA);
  if Assigned(P) then begin P.Print(F);  P.Free;  end;

  Writeln(F,'-----------------------------------');
  Close(F)
end;
*)
//////////////////////////////////////////////////////////////
var
    S : string;
    Start, Time : TDateTime;
    i, N1, N2 : integer;

begin
  try
    Gr:= TGraphChars.Load('Inp_1.txt');
    //Gr:= TGraphChars.Load('Test_1.txt');  // 
    //Gr:= TGraphChars.Load('Page35.txt');  // 
    //Gr:= TGraphChars.Load('Cycle.txt');
    //Gr:= TGraphChars.Load('Test_2.txt');
    //Gr:= TGraphChars.Load('Test_3.txt');
    //Gr:= TGraphChars.GenRandom(true, 0, 10, 26, 50);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
  repeat
    Write('S:= '); Readln(S);  //     -  
    if Length(S)<2 then break; //  

    //  ,     :

    NodeA:= Gr.GetNode(Upcase(S[1]));
    NodeB:= Gr.GetNode(Upcase(S[2]));

    P1:= Gr.GenDijkstra(NodeA, NodeB);
    if Assigned(P1) then begin
      P1.Free;
      Start:= Now;  N1:=0;
      repeat
        for i:=1 to 1000 do begin
          P1:= Gr.GenDijkstra(NodeA, NodeB);
          P1.Free;
        end;
        Inc(N1);
        Time:= MilliSecondsBetween(Start, Now);
      until Time>1000;

      Start:= Now;  N2:=0;
      repeat
        for i:=1 to 1000 do begin
          P2:= Gr.GenQuickPath(NodeA, NodeB);
          P2.Free;
        end;
        Inc(N2);
        Time:= MilliSecondsBetween(Start, Now);
      until Time>1000;

      Writeln('QuickPath / Dijkstra = ', N2/N1:5:1);
    end;

    //Write('q - Quit : '); Readln(S);
  until false; //S='q';
  Gr.Free;
  ///////////////////////////////////////////
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
