// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//      
//     
// (  )
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


procedure TGraph.InitMap_Dijkstra;

var  Que : TBuffer;  //  

  //- - - - - - - - - - - - - - - - - - - - -
  //    
  //    

  procedure Local(aNode: TNode);
  var  Link : TLink;    //  

    //- - - - - - - - - - - - - - - - - - - - -
    //     

    procedure CreateFarLinks(arg: TNode);
    var L1,L2 : TFarLink;    //   
         Flag : boolean;     //    
    begin
      with arg do begin
        L1:= mFarLinks.GetFirst as TFarLink;  //  .  
        while Assigned(L1) do begin
          //   
          if L1.mNodeFar <> aNode then begin
            //      
            L2:= aNode.GetFarLink(L1.mNodeFar); //  .  
            Flag:= not Assigned(L2);
            if Assigned(L2) and (L2.mDist > L1.mDist + mDist) then begin
              //   ,   ,  
              Flag:= true;
              aNode.mFarLinks.Delete(L2);
              L2.Free;
            end;
            if Flag then begin
              //        aNode:
              L2:= TFarLink.Create(
                      Link.mDest,       // Near
                      L1.mNodeFar,      // Far
                      L1.mDist + Link.mDest.mDist - aNode.mDist
                      );
              aNode.mFarLinks.Insert(L2);
            end;
          end; // if
          L1:= mFarLinks.GetNext as TFarLink;       //  
        end; // while
      end; // whith
    end;
    //- - - - - - - - - - - - - - - - - - - - -

  begin
    Link:= aNode.OutLinkFirst; //   
    //     :
    while Assigned(Link) do begin
      if Link.mDest.mPred = aNode then begin
        Local(Link.mDest);  //  
        //       
        CreateFarLinks(Link.mDest);
      end; // if
      Link:= aNode.OutLinkNext;  //  . 
    end; // while
  end;

  //- - - - - - - - - - - - - - - - - - - - -
  //          aNode

  procedure DijkstraLocal(aNode: TNode);
  var Node : TNode;      //  
      Link : TLink;      //  

  begin
    ResetNodes;              //     
    aNode.mColor:= CGray;    //  = 
    aNode.mDist:= 0;         // 
    Que.Push(aNode);         //   
    repeat                   // ,    
      Node:= TNode(Que.Get); //   
      Link:= Node.OutLinkFirst; //   
      //     :
      while Assigned(Link) do begin
        // .  :
        with Link do begin
          //     
          if mDest.mDist > Node.mDist + mValue +
                           Ord(mLoadNodes)*Node.mValue then begin
            //      ,
            //     
            // mDest -   
            mDest.mDist:= Node.mDist + mValue + Ord(mLoadNodes)*Node.mValue;
            mDest.mPred:= Node;  //   
            //      ,   ,
            //      (,  )
            if mDest.mColor <> CGray
              then mDest.mColor:= CWhite; //    .  
          end; // if
          if mDest.mColor = CWhite then begin
            //      
            mDest.mColor:= CGray;     //  
            Que.Push(mDest);          //    
          end; // if
        end;  // whith
        Link:= Node.OutLinkNext;  //  . 
      end; // while
      Node.mColor:= CBlack;  // ,   (Black or Green)
    until Que.GetCount = 0;  // ,   

    Local(aNode);  //   
  end;  // DijkstraLocal
  //- - - - - - - - - - - - - - - - - - - - -

var  Node : TNode;   //  

begin  { TGraph.InitMap }

  //   :
  Node:= mNodes.GetFirst as TNode;     //  
  while Assigned(Node) do begin        //  
    with Node do begin
      if Assigned(mFarLinks)           //   
        then mFarLinks.ClrAndDestroy   // 
        else mFarLinks:= CreateSet;    //   
      //        :
      mFarLinks.Insert(TFarLink.Create(Node, Node, 0));
    end;
    Node:= mNodes.GetNext as TNode;    // . 
  end;

  Que:= TBuffer.Create;  //    ()

  //  :
  Node:= mNodes.GetFirst as TNode;     //  
  while Assigned(Node) do begin        //  
    mNodes.PositionPush;               // .  
    DijkstraLocal(Node);               //  
    mNodes.PositionPop;                // .  
    Node:= mNodes.GetNext as TNode;    // . 
  end;
  Que.Free;   //  
end;
