program Compare_Time;
{
        
  -   TGraph.GenPairs_Edmonds
  -     TGraph.GenPairs_Dissect
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Math,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';


const CMode = pMaxW;  //    
      CPack= 1000;    //    GenPairs_Edmonds

var
  Nodes: integer;     //   
  Density: integer;   //  , %
  Retry: integer;     //   ()
  Time_Dissect: Extended; //    GenPairs_Dissect
  Time_Edmons : Extended; //    GenPairs_Edmonds
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//     ( )

procedure ResultExpo(const aFile: String);
begin
  if aFile <> '' then begin
    Assign(Output, aFile);
    if FileExists(aFile)  then Append(Output)   else Rewrite(Output)
  end;
  Writeln;
  Writeln('---------------------------------------------------');
  Writeln('Nodes=', Nodes:4, ' Retry=', Retry:4, ' Dens=', Density,' %');
  Writeln('Dissect= ', Time_Dissect/Retry:7:1,' ms');
  Writeln('Edmons = ', Time_Edmons/Retry:7:3,' ms');
  Writeln('Dissect/Edmons= ', Time_Dissect/Time_Edmons:7:0,
          '  Lg =',Log10(Time_Dissect/Time_Edmons):5:2);
  Writeln('---------------------------------------------------');
  if aFile <> '' then begin
    Close(Output);  Assign(Output, '');    Rewrite(Output);
  end;
end;
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

var
  Graph: TGraph;      //  
  Pairs: TCostSet;    //  
  Start: TDateTime;   //  
  Time : integer;     //  
  k, i: integer;      // 

begin
  try
  repeat
    //     (+, -)
    Write('Nodes     (>4) = '); Readln(Nodes);
    if Abs(Nodes)<5 then Break;
    //   , %
    Write('Density,% (>0) = '); Readln(Density);
    if Abs(Density)<1 then Break;
    //   
    Write('Retry     (>0) = '); Readln(Retry);
    if Retry<=0 then Break;

    Time_Dissect:= 0; Time_Edmons:= 0;
    for i:= 1 to Retry do begin
      Write('.');
      //   
      Graph:= TGraphChars.GenRandom(
              false,  //  
              1,      //  
              99,     //  ,   = 99
              Nodes,  //  ,  
              Density //  , %  
              );
      //   GenPairs_Edmonds
      Start:= Now; //   
      //   
      for k:=1 to CPack do begin
        Pairs:= Graph.GenPairs_Edmonds(CMode);
        Pairs.Free; //  
      end;
      //   
      Time:= MilliSecondsBetween(Start, Now);
      //    GenPairs_Edmonds
      Time_Edmons:= Time_Edmons + Time/CPack;

      //   GenPairs_Dissect
      Start:= Now; //   
      Pairs:= Graph.GenPairs_Dissect(CMode);
      Pairs.Free;  //  
      //  
      Time:= MilliSecondsBetween(Start, Now);
      //    GenPairs_Dissect
      Time_Dissect:= Time_Dissect + Time;

      Graph.Free;  //  
    end;  // for  i:= 1 to Retry
    ResultExpo('');
    ResultExpo('#Compare_Time.txt');
  until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

