program Graph_33a;
{$APPTYPE CONSOLE}
{
    
}
uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

//    

function HamToStr(aBuf: TBuffer): string;
var N: TNode;
    i: integer;
begin
  Result:='';
  for i:= 1 to aBuf.GetCount do begin
    N:= aBuf.Get as TNode;
    aBuf.Put(N);
    Result:= Result+ N.GetName;
    if i<aBuf.GetCount then Result:=Result +'-';
  end;
end;

var Gr : TGraph;
    Res : TBuffer;
    Cost: integer;
    Nodes: integer;
    Start, Time : TDateTime;
    N, N1, N2 : integer;

procedure Test;
const CRet = 80;
var i: integer;
    ok: boolean;
    Err, T1, T2, C1, C2 : integer;
begin
  Err:= 0; T1:= 0; T2:= 0;
  for i:= 1 to CRet do begin
    Gr:= TGraphChars.GenFull((Nodes>0), 0, 99, Abs(Nodes));

if Abs(Nodes) <=15 then begin
    Start:= Now;
    Res:= Gr.GenHamilton_Full(C1);
//    Res:= Gr.GenHamilton_Quick(C1);
    T1:= T1 + MilliSecondsBetween(Start, Now);
    Res.Free;
end;

    Start:= Now;
    Res:= Gr.GenHamilton(C2);
    T2:= T2 + MilliSecondsBetween(Start, Now);
    Res.Free;
    if C1=C2 then Write('.') else begin Write('*'); Inc(Err) end;
    Gr.Free;
  end;

  Writeln(#10,'Err2=',Err:3, ' = ', 100*Err/CRet:6:2,' %');
  Writeln('T1=', T1/CRet:8:2, ' ms');
  Writeln('T2=', T2/CRet:8:2, ' ms');
  Writeln('==========================');
  Readln;
end;

begin
  try
    repeat
      Write(#10'Nodes= '); Readln(Nodes);
      if Abs(Nodes)<3 then Break;
//      Test;  Break;

//Assign(Output, 'Trace.txt'); Rewrite(Output);
//Nodes:=7;
      {
        Nodes > 0 -- ,  Nodes < 0 -- 
      }
//      Gr:= TGraphChars.GenFull((Nodes>0), 0, 99, Abs(Nodes));
//      Gr:= THugeGraph.GenFull(false, 0, 99, Nodes);  // 
//      Gr:= TGraphChars.GenRandom(false, 0, 50, Nodes, 40);
//(Gr as TGraphChars).Save('Random.txt');
//Gr:= TGraphChars.Load('Full_14.txt');
//Gr:= TGraphChars.Load('Random-9.txt');
//Gr:= TGraphChars.Load('Full_10.txt');
      Gr:= TGraphChars.Load('Kristofides-301.txt'); //  
      if Gr.Nodes<10 then Gr.Expo;

      if Gr.Nodes < 18 then begin
        Writeln('-------------- Full -------------------');
        Start:= Now;
        Res:= Gr.GenHamilton_Full(Cost);
        Time:= MilliSecondsBetween(Start, Now);
        Writeln(HamToStr(Res));
        Res.Free;
        Write('Cost   = ', Cost);
        Writeln('  Time (ms) =', Time:5:0, #10);
      end;
      Writeln('-------------- Main -------------------');
      Start:= Now;
      Res:= Gr.GenHamilton(Cost);
      Time:= MilliSecondsBetween(Start, Now);
      Writeln(HamToStr(Res));
      Res.Free;
      Write('Cost(T)= ', Cost);
      Writeln('  Time (ms) =', Time:5:0, #10);
      N:= Cost;

//      if not Gr.mDirect then begin
        Writeln('-------------- Quick -------------------');
        Start:= Now;
        Res:= Gr.GenHamilton_Quick(Cost);
        Time:= MilliSecondsBetween(Start, Now);
        Writeln(HamToStr(Res));
        Res.Free;
        Write('Cost= ', Cost);
        Writeln('  Time (ms) =', Time:5:0, #10);
        Writeln('R1= ', 100*Cost/N:6:1, ' %');
//      end;

    if Cost>0 then begin
      //    
      Writeln('-------------- Greed true -------------------');
      Start:= Now;
      Res:= Gr.GenHamilton_Greed(Cost, true);
      Time:= MilliSecondsBetween(Start, Now);
      Writeln(HamToStr(Res));
      Res.Free;
      Write('Cost= ', Cost);
      Writeln('  Time (ms) =', Time:5:0, #10);
      Writeln('R2= ', 100*Cost/N:6:1);

      Writeln('-------------- Greed false -------------------');
      Start:= Now;
      Res:= Gr.GenHamilton_Greed(Cost, false);
      Time:= MilliSecondsBetween(Start, Now);
      Writeln(HamToStr(Res));
      Res.Free;
      Write('Cost= ', Cost);
      Writeln('  Time (ms) =', Time:5:0, #10);
      Writeln('R3= ', 100*Cost/N:6:1);
      Writeln('----------------------------------------------'#10);
    end;

//Close(Output); Assign(Output, ''); Rewrite(Output);
      Gr.Free;
    until false;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.

